#include <stdio.h>

#define PEGS         3
#define COLORS       3
#define LOWER_BOUND  1

/* Define how many times the additional color can appear in the guess. */
#if LOWER_BOUND
#define ADD_COLORS  (PEGS - 1)
#else
#define ADD_COLORS  0
#endif

int pegs[COLORS + ADD_COLORS];

static void print(void) {
  int i;

  for (i = 0; i < PEGS; ++i)
    printf("%c", 'a' + pegs[i]);
  printf("\n");
}

static void init(void) {
  int i;

  for (i = 0; i < COLORS; ++i)
    pegs[i] = i;
  for (; i < COLORS + ADD_COLORS; ++i)
    pegs[i] = COLORS; /* Initialize the rest with the additional color. */
}

static int next(void) {
  int i, j, k, l, tmp;

  if (pegs[PEGS - 1] < pegs[COLORS + ADD_COLORS - 1]) {
    for (j = PEGS; j < COLORS + ADD_COLORS; ++j) {
      if (pegs[j] > pegs[PEGS - 1]) {
        tmp = pegs[PEGS - 1];
        pegs[PEGS - 1] = pegs[j];
        pegs[j] = tmp;
        return 1;
      }
    }
  }
  else {
    for (i = PEGS, k = COLORS + ADD_COLORS - 1; i < k; ++i, --k) {
      tmp = pegs[i];
      pegs[i] = pegs[k];
      pegs[k] = tmp;
    }
    j = PEGS - 2;
    while (j >= 0 && pegs[j] >= pegs[j + 1])
      --j;
    if (j < 0)
      return 0;
    l = COLORS + ADD_COLORS - 1;
    while (pegs[j] >= pegs[l])
      --l;
    tmp = pegs[j];
    pegs[j] = pegs[l];
    pegs[l] = tmp;
    for (i = j + 1, k = COLORS + ADD_COLORS - 1; i < k; ++i, --k) {
      tmp = pegs[i];
      pegs[i] = pegs[k];
      pegs[k] = tmp;
    }
  }
  return 1;
}

int main() {
  init();
  print();
  while (next())
    print();

  return 0;
}
